/* extmain.skel include file for extraction
 * $Log: extmain.skel,v $
 * Revision 1.19  1999/11/18 19:30:33  nort
 * Added <math.h> for floor() as generated for conversions
 *
 * Revision 1.18  1995/10/18  02:05:48  nort
 * Changes to nlcon_display()
 *
 * Revision 1.17  1995/10/06  16:40:02  nort
 * Changes to nlcon_disp()
 * Old change to ROWS() and FRACSECS() macros
 *
 * Revision 1.16  1994/08/29  20:29:28  nort
 * Changes for OUI
 *
 * Revision 1.15  1993/09/27  18:55:31  nort
 * Cleaned up RCS log
 * Cleaned up rcsid[] with Watcom pragmas
 * Added #include <string.h> for memcpy prototype.
 *
 * Revision 1.14  1993/05/19  19:04:51  nort
 * Changed OPT_CON_INIT to OPT_CONSOLE_INIT to allow judicious
 * redefinition for TMA.
 */
#include <stdio.h>
#include <string.h>
#include <sys/kernel.h>
#include <unistd.h>
#include <math.h>
#include "oui.h"
#include "dbr.h"
#include "globmsg.h"
#include "msg.h"
#pragma off (unreferenced)
  static char emrcsid[] =
	"$Id: extmain.skel,v 1.19 1999/11/18 19:30:33 nort Exp nort $";
#pragma on (unreferenced)



 typedef unsigned short UINT;


 typedef unsigned char UCHAR;
	unsigned short InjectingInc = 0;


 typedef unsigned long ULONG;
ULONG CHROMtime;
#include "convfunc.h"
#include "ttdriver.h"
#include "defcals.h"

int tt_p4=72;
int tt_p3=48;
int tt_p2=24;
int tt_p1=0;




	
	

	 typedef float adT;
	 typedef float adT_flow;
	 typedef float vdc_chan;
	 typedef float vdc_pow;
	 typedef float adT_pump;

	 typedef float dacMSpr;

	 typedef UINT InjStateT;

float read_atod(int atod_chan) {
	
	unsigned short atod_val;
	float voltage = -99999;

	atod_val = tt_read_atod( atod_chan );
	atod_val = atod_val + 2048;
	atod_val = atod_val & 0xFFF;

	if (atod_val >= 2048)	{
		atod_val = atod_val|(0xF000);
		atod_val=~atod_val;
		++atod_val;
		voltage = -10.0 * ((float) atod_val) / 2048.0;
		//	printf("reading atod channel %i value is negative %i \n",atod_chan, atod_val);
	} else 	{
		voltage = 10.0 * ((float) atod_val) / 2048.0;
	//	printf("reading atod channel %i value is %f \n",atod_chan,voltage);

	}	

	return voltage;
}


float read_temp(int address) { 
	float voltage;

	voltage = read_atod(address);

	return convert_temps(voltage);
}


float read_temp12v(int address) { 
	float voltage;

	voltage = read_atod(address);

	return convert_temps12v(voltage);
}

float read_ad_value(int address, float R1, float V1, float V0) { 
	float Vx;

	Vx = read_atod(address);

	if (Vx < 0)
		Vx = -Vx;

	return convert_VtoR( Vx, R1, V1, V0 );

}



#include "valves.h"
#include "address.h"





	 typedef unsigned char DigOutWd;
	 typedef DigOutWd DigInWd;



	 typedef short DigBit;
	 typedef DigBit Bit_HI_LO;
	 typedef DigBit Bit_Op_Cl;
	 typedef DigBit Bit_Cl_Op;
	 typedef DigBit Bit_On_Off;
	 typedef DigBit Bit_Off_On;
	 typedef DigBit Bit_Air_Cal;
	 typedef DigBit Bit_offline;


	UCHAR MSDstateS;

int read_dig_in (unsigned short dig_chan)  {
	
	unsigned short dig_val;
	unsigned short address;
	int value;

	address=dig_chan/8;	
	dig_val=tt_read_digital(address);
	address=dig_chan-address*8;
	value=1<<address;
	//	address=pow(2,address);
	dig_val=dig_val&value;
	if (dig_val==0)
		return 0;
	return 1;
}

int read_dig_out(int chan) {

	return read_dig_in(chan+64);
}


int fail_board(int digch) {
	static int fail_toggle = 0;
	
	if (fail_toggle==0) {
		tt_scdc_command(100 + digch);
		fail_toggle = 1;
		return fail_toggle;
	}

	fail_toggle = 0;
	tt_scdc_command(digch);
	return fail_toggle;
}

// used to pulse a digch (hard coded for dig 20 and 21
// and MSDstate 4 and 5).
int trapToggle( int digch ) {
	static int pulse1 = 0;
	static int pulse2 = 0;
	int	pulse, state;
	const int trap1add = 20;
	const int trap2add = 21;

	if (digch == trap1add) {
	 	state = 4;
		pulse = pulse1;
	} else if (digch == trap2add) {
		state = 5;
		pulse = pulse2;
	} else {
		return 0;
	}

	// toggle dig line
	if ( MSDstateS == state ) {
		switch ( pulse ) {
			case 0:		// off, turn on
				tt_scdc_command( 100 + digch );
				pulse = 1;
				break;
			case 1:		// on, turn off
				tt_scdc_command( digch );
				pulse = 0;
				break;
		}
	} else {
		if ( pulse == 1 ) {
			tt_scdc_command( digch );
			pulse = 0;
		}
	}

	if (digch == trap1add)
		pulse1 = pulse;
	else
		pulse2 = pulse;

	return read_dig_out( digch );

}


#include <sys/types.h>
pid_t rs485_proxy;
short Omega485[34];

short OmegaArray( int add ) {
	return Omega485[add];
}



 typedef short OmegaT;

 typedef short OmegaTsp;
#include <math.h>
#include <sys/name.h>
#include <sys/kernel.h>
#include <sys/types.h>
#include <stdlib.h>
#include "/home/panther/drivers/smart/smart.h"
#include "regnames.h"
#include "panthermsg.h"

#define 		ECDOFFLINE 		-9999
#define			NUMSECSXAXIS	 150
#define			ELECRATE		0.1			// seconds

pid_t			ECDresp_proxy;

chrom_packet 	ECDresp[MAXDET];

long int 		DetAvgCt1=0, DetAvgCt2=0, DetAvgCt3=0, DetAvgCt4=0,
		 		DetAvgOffline1=0, DetAvgOffline2=0, DetAvgOffline3=0, DetAvgOffline4=0,
	 			ecd_sum1=0, ecd_sum2=0, ecd_sum3=0, ecd_sum4=0,
				ecdA_SF6save=0, ecdA_F11save=0, ecdA_COsave=0, ecdA_PANsave=0;
float			ecdSF6x = 0.0, ecdF11x = 0.0, ecdCOx = 0.0, ecdPANx = 0.0;
int				currPoint[MAXDET];

// function gets the data from shared data array with smart driver
long int GC_Ctr_Pull( int elecADD ) {
	long ecdDATA;
	
	if ( currPoint[elecADD] >= MAXPOINTS ) currPoint[elecADD] = 0;

	// new data
	if ( currPoint[elecADD] < ECDresp[elecADD].numpnts ) {
		ecdDATA = ECDresp[elecADD].resp[currPoint[elecADD]];
		currPoint[elecADD]++;
	} 
	else {
		ecdDATA = ECDOFFLINE;
		currPoint[elecADD] = 0;
		ECDresp[elecADD].numpnts = -1;
	}

	return ecdDATA;	
}




 typedef long GC_Freq;
 typedef long GC_Ctr;

GC_Freq ecdA_SF6, ecdA_F11, ecdA_CO, ecdA_PAN;

 typedef unsigned char UNYBL;


 typedef unsigned long InjFile;

InjFile ITXFileNum;




ULONG CUMSEC;
#include <sys/types.h>
pid_t valco_proxy;
int valvePos[10] = {0,0,3,3,3,3,3,3,3,3};


 typedef short valvT;
 typedef DigBit valvetext;
 typedef DigBit valveMS1text;
 typedef DigBit valveMS2text;
#include <math.h>
#include <sys/name.h>
#include <sys/kernel.h>
#include <sys/types.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "da_cache.h"
#include "regnames.h"

#define MAXMSDCHANS 	  8		// Max number of MS channels
#define MAXMSDIONS 		 30		// Max number of ions per channel
#define MAXMSDPOINTS 	 30		// Max Number of data points in a second for an ion
#define MSDOFFLINE 	  -9999
#define MSDMISSING	   -999
#define MAXSENDMSG     2000		// max number of chars from the msd server
#define SEPCHARS		":,()"
#define MSDIONFILE		"/home/panther/flight/msd.ions"

pid_t		MSDresp_proxy;

long int 	MSD_Data_Array[MAXMSDCHANS][MAXMSDPOINTS],
			MSD_Time_Array[MAXMSDPOINTS],
			msdTIMEoldPlot,
			MSchanAvg[MAXMSDCHANS],
			msd_sum[MAXMSDCHANS],
			MSD_ChanX;

unsigned int 	currMSDPoint[MAXMSDCHANS],
				chanInc;

unsigned char 	MSDresp[MAXSENDMSG];		// data returned by msd

struct MSwindow {
	float	ion;			// ion number
	float	dwell;			// dwell time (0 < dwell <= 1) (fraction of a second)
} MStable[MAXMSDCHANS][MAXMSDIONS];


int ReadMSDionFile ( char *IONFILE ) {
	FILE 	*fp;
	char 	buffer[1000];
	char 	*p;
	char	tmp[1];
	int		chan, inc;
	static char	once;
	double	ion, dwell;

	if (once == 1) return 0;

	fp = fopen(	IONFILE, "r" );
	if (fp == NULL) {
		fprintf(stderr, "Open failed: Cannont find %s\n", IONFILE);
		return -1;
	} else {
		while ( fgets( buffer, 1000, fp ) != NULL ) {

			// First strip out the MS channel number
			p = strstr( strlwr(buffer), "mschan" );
			strncpy(tmp, p + strlen("MSchan"), 1);
			chan = atoi(tmp);
			if (chan >= MAXMSDCHANS)
				break;
		
			// Next strip out the ions and dwell times
			p =	strtok(buffer, SEPCHARS );
			inc = 0;
			while ( p != NULL ) {

				if ( strstr(strlwr(p), "null") != NULL ) {
					MStable[chan][inc].ion = 0;
					MStable[chan][inc].dwell = 0;
					inc++;
				} else {
					ion = atof(p);
					if (ion >= 1) { 		// found ion
						p = strtok( NULL, SEPCHARS );
						dwell = atof(p);
						if (( dwell <= 1 ) && ( dwell > 0 )) {
							MStable[chan][inc].ion = ion;
							MStable[chan][inc].dwell = dwell;
							//printf ("%d,%d: %f %f\n", chan, inc, ion, dwell);
						} else {
							MStable[chan][inc].ion = 0;
							MStable[chan][inc].dwell = 0;
							fprintf(stderr, "Bad dwell time for channel %d, ion %f\n", chan, ion);
						}

						inc++;
					} else {
						MStable[chan][inc].ion = 0;
						MStable[chan][inc].dwell = 0;
						//printf("null ion: chan = %d, inc = %d\n", chan,inc);
					}

				}

				p = strtok( NULL, SEPCHARS );
			}
		}
	}

	fclose(fp);
	once = 1;

	return 0;

}

// Function takes a ion number and returns the MS channel number for
// a given time window.
int ion2chan( int win, float ion ) {

	int ch;
	float tol = 0.001;

	// Out of range variable
	if (win > MAXMSDIONS)
		return -1;

	// Scan MStable array for match
	for(ch=0; ch < MAXMSDCHANS; ch++) {
		if (((MStable[ch][win].ion - tol) < ion) && ((MStable[ch][win].ion + tol) > ion))
			return ch;
	}

	// No match in this time window
	return -1;

}

// Functions to pull data from MSD_Data and Time arrays.
long int MSD_Chan_Pull( int chan, int type ) {
	long msdDATA;
	static long msdTIMEold;

	if (currMSDPoint[chan] > MAXMSDPOINTS) 
		currMSDPoint[chan] = MAXMSDPOINTS;

	// type 0 is msd resp data, type 1 is msd time data.
	if ( type == 0 ) {
		msdDATA = MSD_Data_Array[chan][currMSDPoint[chan]];
		currMSDPoint[chan]++;
	} 
	else if ( type == 1 ) {		// real time displayed on text string.
		msdDATA = MSD_Time_Array[currMSDPoint[chan]-1];
		if ( msdDATA == MSDMISSING )
			msdDATA = msdTIMEold;
		else
			msdTIMEold = msdDATA;
	}
	else if ( type == 2 ) {		// this time needs to be monitonically increasing for rtg.
		msdDATA = MSD_Time_Array[currMSDPoint[chan]-1];
		if ( msdDATA == MSDMISSING )
			msdDATA = msdTIMEoldPlot++;
		else if ( msdDATA <= msdTIMEoldPlot ) {
			if ( msdDATA > msdTIMEoldPlot )
				msdDATA = msdDATA + 10;	
			else
				msdDATA = msdTIMEoldPlot + 10;
		}
		msdTIMEoldPlot = msdDATA;
	}

	return msdDATA;	
}




 typedef unsigned short WinNum;

 typedef long MSD_DataType;

MSD_DataType msdA_0, msdA_1, msdA_2, msdA_3, msdA_4, msdA_5, msdA_6, msdA_7, msdA_8;

int MSD_load( unsigned short IonWinNum ) {

	char *p;
	unsigned int chaninc[MAXMSDCHANS], inc, i, c;
	int chan = 0;
	float ion;

	// Initialize global currMSDPoint to 0
	for(c=0; c < MAXMSDCHANS; c++) {
		chaninc[c] = 0;
		currMSDPoint[c] = 0;
	}

	// Fills in MSD_Data_Array with "missing" data MSDMISSING
	for(i=0; i < MAXMSDPOINTS; i++) {
		for(c=0; c < MAXMSDCHANS; c++) {
			MSD_Data_Array[c][i] = MSDMISSING;
			if (c == 0)
				MSD_Time_Array[i] = MSDMISSING;
		}
	}

	// Parse data returned in string MSDresp
	p = strtok(MSDresp, ",");
	inc = 0;
	while( p != NULL ) {

		// Get ion number
		if ( (inc % 3) == 0 ) {
			ion = atof(p);
			chan = ion2chan(IonWinNum, ion);
			// printf("ion = %f, chan = %d\n", ion, chan);
		} 

		// response data
		else if ( (inc % 3) == 1 ) {
			// Set data array
			if ((chan >= 0) && (chan < MAXMSDCHANS)) {
				MSD_Data_Array[chan][chaninc[chan]] = atol(p);
				chaninc[chan]++;
				if (chaninc[chan] > MAXMSDPOINTS) {
					chaninc[chan] = MAXMSDPOINTS;
					break;
				}
			}
		} 

		// time data
		else if ( (inc % 3) == 2 ) {
			if (chan == 0)
				MSD_Time_Array[chaninc[chan] - 1] = atol(p);
		} 

		p = strtok(NULL, ",");
		inc++;
	}

	// Set MSDresp array to 0
	for (i=0; i<MAXSENDMSG; i++) 
		MSDresp[i] = '\0';
	
	return 1;

}		



	unsigned short InjectingInc_MSD = 0;


ULONG MSDchromtime;
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include "regnames.h"

#define MAXMON 	19		// should match number in msd driver

pid_t	MSDeng_proxy;
float 	MSDeng[MAXMON];

void InitializeMSDeng() {
	int param;
	static char once;

	if (once == 1) return;

	for (param=0; param<MAXMON; param++)
		MSDeng[param] = -99.0;

	once = 1;

}




 typedef double MSDdouble;
#include <sys/types.h>
#include "maycomm.h"
pid_t maycomm_proxy = 0;

TDLstruct tdl;

#define USELONGPATH  900	// use the long path TDL when less than 900 ppm



 typedef float tdlfloat;
 typedef float tdlfloas;
 typedef short tdlint6;
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "nortlib.h"
#include "globmsg.h"
#include "ttdriver.h"
#include "dac.h"


	#include "reveal.h"
	char revealMSG[REVEAL_MAXDATA];
	int revinc=0;

  #include "nortlib.h"
  #include "tma.h"
  char ci_version[] = "$CGID: gndcmd.c: Fri Jun 22 21:17:50 2007 $";

  tma_state initialize_cmds_[] = {
       0, ">Telemetry Start\n",
       5, "#3", /* REVEAL */
      -1, NULL
  };

  tma_state REVEAL_Idle_cmds_[] = {
      -1, NULL
  };

  tma_state REVEAL_cmds_[] = {
      -1, NULL
  };

  const int tma_n_partitions = 2;

#ifdef CONSOLE_INIT
  #error CONSOLE_INIT is obsolete
#endif
#ifdef MSG_LABEL
  #error MSG_LABEL is obsolete
#endif

#ifdef N_CONSOLES
  #include "nl_cons.h"
  #ifndef DATA_ATTR
	#define DATA_ATTR 7
  #endif

  #define cdisplay(d,r,c,s) nlcon_display(d,r,c,s,DATA_ATTR)
  #define display_(d,r,c,t,v,s) {\
	static t sv_;\
	if (v != sv_) { cdisplay(d,r,c,s); sv_ = v; }\
  }
#endif


unsigned char V0 = 0x1;
unsigned char V1 = 0x1;
unsigned char V2 = 0x1;
unsigned char V3 = 0x1;
unsigned char V4 = 0x1;
unsigned char V5 = 0x1;
unsigned char V6 = 0x1;
unsigned char V7 = 0x1;
unsigned char V8 = 0x1;
unsigned char V9 = 0x3;
unsigned int V10 = 0x3FFF;
adT PresE_CO;
vdc_chan VoltBP_CO;
vdc_chan VoltE_SF6;
adT PresE_F11;
adT PresSrc_PAN;
vdc_chan VoltM_PAN;
adT PresE_5;
vdc_chan VoltBP_5;
adT Flow_MSsl;
adT Flow_Packsl;
adT Flow_PANsl;
adT PresH_He;
adT PresH_N2;
adT Temp_GasBot;
MSDdouble msdREP;
MSDdouble msdAMUG;
MSDdouble msdIFOC;
MSDdouble msdFSEL;
MSDdouble msdENTO;
MSDdouble msdCAL;
MSDdouble msdSRCTEMP;
MSDdouble msdTURBOPCT;
MSDdouble msdMASO;
tdlfloas tdlP;
tdlfloas tdlT;
tdlfloat tdllH2O;
tdlfloat tdlbH2O;
union {
  struct {
    UINT MFCtr;
    GC_Ctr GC_Ctr_CO;
    GC_Ctr GC_Ctr_F11;
    GC_Ctr GC_Ctr_PAN;
    GC_Ctr GC_Ctr_SF6;
    Bit_Off_On PANlamp;
    Bit_Off_On trap2heat;
    char U1[1];
    adT PresBP_CO;
    adT_flow FlowB_CO;
    adT_flow FlowM_CO;
    UINT Synch;
  } U0;
  struct {
    char U3[2];
    MSD_DataType MSD_TimePlot;
    MSD_DataType MSD_Time;
    MSD_DataType MSD_Chan5;
    MSD_DataType MSD_Chan4;
    Bit_Off_On trap1heat;
    Bit_Air_Cal PANsol1;
    char U4[2];
    UINT CurrFile;
    adT Pres2_PAN;
    char U5[1];
    adT_flow FlowM_SF6;
  } U2;
  struct {
    char U7[18];
    OmegaT SF6_Post;
    OmegaT F11_ECD;
    char U8[1];
    adT PresBP_F11;
    adT_flow FlowB_SF6;
    adT PresBP_SF6;
  } U6;
  struct {
    char U10[18];
    OmegaT Trap2_CB;
    OmegaT CO_ECD;
    char U11[1];
    adT PresBP_5;
    adT PresE_SF6;
    vdc_chan VoltM_SF6;
  } U9;
  struct {
    char U13[18];
    OmegaTsp F11_Col_Sp;
    OmegaTsp SF6_Post_Sp;
    char U14[2];
    vdc_chan VoltB_CO;
    UINT CurrInj;
    adT Pres1_PAN;
    UCHAR GCstate;
  } U12;
  struct {
    char U16[18];
    OmegaTsp CO_Col_Sp;
    OmegaTsp Trap2_CB_Sp;
    adT Temp_Ipump;
    adT Temp_PANsrc;
    adT Temp_SF6sl;
    UCHAR MSDstate;
  } U15;
  struct {
    char U18[18];
    valveMS2text valv_MS2;
    valveMS1text valv_MS1;
    Bit_HI_LO faildummy;
    vdc_chan VoltE_CO;
    vdc_chan VoltM_CO;
    char U19[3];
  } U17;
  struct {
    char U21[18];
    MSD_DataType MSD_Chan3;
    Bit_Cl_Op SLoopIN;
    vdc_chan VoltB_F11;
    char U22[2];
    Bit_Off_On pelt2State;
    char U23[3];
  } U20;
  struct {
    char U25[18];
    char U26[1];
    MSDdouble msdIPOL;
    vdc_chan VoltB_SF6;
    vdc_chan VoltBP_SF6;
  } U24;
  struct {
    char U28[18];
    char U29[2];
    MSDdouble msdEEGY;
    vdc_chan VoltM_F11;
    char U30[3];
  } U27;
  struct {
    char U32[18];
    char U33[3];
    MSDdouble msdAMUO;
    adT PresE_PAN;
    char U34[2];
  } U31;
  struct {
    char U36[18];
    char U37[4];
    Bit_Off_On trap2relay;
    char U38[2];
    Bit_Cl_Op SLoopOUT;
    vdc_chan VoltB_PAN;
    char U39[3];
  } U35;
  struct {
    char U41[18];
    char U42[5];
    MSDdouble msdMMW;
    adT_flow FlowM_F11;
  } U40;
  struct {
    char U44[18];
    char U45[6];
    char U46[1];
    adT_flow FlowSrc_PAN;
    char U47[6];
  } U43;
  struct {
    char U49[18];
    char U50[7];
    MSDdouble msdEMUL;
    char U51[2];
  } U48;
  struct {
    char U53[18];
    char U54[5];
    MSDdouble msdMASG;
    vdc_chan VoltBP_F11;
  } U52;
  struct {
    char U56[18];
    char U57[3];
    tdlfloat tdlsH2O;
    tdlfloas tdlT;
    tdlfloas tdlP;
    OmegaT CO_Col;
  } U55;
  struct {
    char U59[18];
    tdlint6  tdllZer;
    tdlint6  tdllPos;
    Bit_Cl_Op PANsol2;
    vdc_chan VoltE_PAN;
    vdc_chan VoltMS1;
    Bit_Cl_Op PANflsh;
    char U60[1];
  } U58;
  struct {
    char U62[22];
    OmegaTsp F11_ECD_Sp;
    vdc_chan VoltMS2;
    Bit_Off_On pelt1State;
    Bit_Off_On PANflowCont;
    Bit_HI_LO pilotTrip;
    char U63[1];
  } U61;
  struct {
    char U65[22];
    OmegaTsp CO_ECD_Sp;
    Bit_Op_Cl SLoopMSout;
    Bit_Op_Cl PANsol4;
    OmegaT Trap1_CB;
    OmegaT SF6_ECD;
    Bit_Off_On trap1relay;
    char U66[1];
  } U64;
  struct {
    char U68[22];
    valvetext valv_PAN;
    Bit_Off_On PANsol3;
    OmegaT SF6_Col;
    OmegaTsp SF6_Col_Sp;
    OmegaTsp Trap1_CB_Sp;
    OmegaT F11_Col;
    char U69[1];
  } U67;
  struct {
    char U71[22];
    MSD_DataType MSD_Chan2;
    OmegaT PAN_ECD;
    OmegaTsp PAN_ECD_Sp;
    valvT ssv2;
    OmegaTsp SF6_ECD_Sp;
    char U72[1];
  } U70;
  struct {
    char U74[22];
    MSDdouble msdENT;
    MSD_DataType MSD_Chan0;
    char U75[1];
  } U73;
  struct {
    char U77[22];
    char U78[4];
    valvetext valv_F11;
    valvetext valv_SF6;
    UINT CurrInj_MSD;
    valvT ssv1;
    char U79[1];
  } U76;
  struct {
    char U81[22];
    tdlint6  tdllPow;
    valvetext valv_CO;
    MSD_DataType MSD_Chan1;
    char U82[5];
  } U80;
  struct {
    char U84[24];
    WinNum IonWinNum;
    UINT CurrFile_MSD;
    char U85[7];
  } U83;
  struct {
    char U87[24];
    UINT loadMSDarray;
    MSDdouble msdQUAD;
    char U88[1];
  } U86;
  struct {
    char U90[24];
    MSDdouble msdHEDEN;
    char U91[3];
  } U89;
  struct {
    char U93[24];
    char U94[3];
    adT_flow FlowB_F11;
    adT PresMS1;
  } U92;
  struct {
    char U96[24];
    tdlint6  tdllAmp;
    ULONG maycX;
    tdlint6  tdlsPow;
    tdlint6  tdlsAmp;
    char U97[1];
  } U95;
  struct {
    char U99[26];
    tdlint6  tdlsZer;
    tdlint6  tdlsPos;
    tdlfloat tdlbH2O;
    char U100[1];
  } U98;
  struct {
    char U102[27];
    vdc_chan VoltE_F11;
    char U103[2];
    char U104[2];
  } U101;
  struct {
    char U106[27];
    adT PresMS2;
    char U107[4];
  } U105;
  struct {
    char U109[27];
    vdc_chan VoltE_5;
    char U110[4];
  } U108;
  struct {
    char U112[27];
    MSDdouble msdECUR;
  } U111;
  struct {
    char U114[34];
    char U115[1];
  } U113;
  struct {
    char U117[34];
    char U118[1];
  } U116;
  struct {
    char U120[34];
    char U121[1];
  } U119;
  struct {
    char U123[34];
    char U124[1];
  } U122;
  struct {
    char U126[34];
    char U127[1];
  } U125;
  struct {
    char U129[34];
    char U130[1];
  } U128;
  struct {
    char U132[34];
    char U133[1];
  } U131;
  struct {
    char U135[34];
    char U136[1];
  } U134;
  struct {
    char U138[34];
    char U139[1];
  } U137;
  struct {
    char U141[34];
    char U142[1];
  } U140;
  struct {
    char U144[34];
    char U145[1];
  } U143;
  struct {
    char U147[34];
    char U148[1];
  } U146;
  struct {
    char U150[34];
    char U151[1];
  } U149;
  struct {
    char U153[34];
    char U154[1];
  } U152;
  struct {
    char U156[34];
    char U157[1];
  } U155;
  struct {
    char U159[34];
    char U160[1];
  } U158;
  struct {
    char U162[34];
    char U163[1];
  } U161;
  struct {
    char U165[34];
    char U166[1];
  } U164;
  struct {
    char U168[34];
    char U169[1];
  } U167;
  struct {
    char U171[34];
    char U172[1];
  } U170;
  struct {
    char U174[34];
    char U175[1];
  } U173;
  struct {
    char U177[34];
    char U178[1];
  } U176;
  struct {
    char U180[34];
    char U181[1];
  } U179;
  struct {
    char U183[34];
    char U184[1];
  } U182;
  struct {
    char U186[34];
    char U187[1];
  } U185;
  struct {
    char U189[34];
    char U190[1];
  } U188;
  struct {
    char U192[34];
    char U193[1];
  } U191;
  struct {
    char U195[34];
    char U196[1];
  } U194;
  struct {
    char U198[34];
    char U199[1];
  } U197;
  struct {
    char U201[34];
    char U202[1];
  } U200;
  struct {
    char U204[34];
    char U205[1];
  } U203;
  struct {
    char U207[34];
    char U208[1];
  } U206;
  struct {
    char U210[34];
    char U211[1];
  } U209;
  struct {
    char U213[34];
    char U214[1];
  } U212;
  struct {
    char U216[34];
    char U217[1];
  } U215;
  struct {
    char U219[34];
    char U220[1];
  } U218;
  struct {
    char U222[34];
    char U223[1];
  } U221;
  struct {
    char U225[34];
    char U226[1];
  } U224;
  struct {
    char U228[34];
    char U229[1];
  } U227;
  struct {
    char U231[34];
    char U232[1];
  } U230;
  struct {
    char U234[34];
    char U235[1];
  } U233;
  struct {
    char U237[34];
    char U238[1];
  } U236;
  struct {
    char U240[34];
    char U241[1];
  } U239;
  struct {
    char U243[34];
    char U244[1];
  } U242;
  struct {
    char U246[34];
    char U247[1];
  } U245;
  struct {
    char U249[34];
    char U250[1];
  } U248;
  struct {
    char U252[34];
    char U253[1];
  } U251;
  struct {
    char U255[34];
    char U256[1];
  } U254;
  struct {
    char U258[34];
    char U259[1];
  } U257;
  struct {
    char U261[34];
    char U262[1];
  } U260;
  struct {
    char U264[34];
    char U265[1];
  } U263;
  struct {
    char U267[34];
    char U268[1];
  } U266;
  struct {
    char U270[34];
    char U271[1];
  } U269;
  struct {
    char U273[34];
    char U274[1];
  } U272;
  struct {
    char U276[34];
    char U277[1];
  } U275;
  struct {
    char U279[34];
    char U280[1];
  } U278;
  struct {
    char U282[34];
    char U283[1];
  } U281;
  struct {
    char U285[34];
    char U286[1];
  } U284;
  struct {
    char U288[34];
    char U289[1];
  } U287;
  struct {
    char U291[34];
    char U292[1];
  } U290;
  struct {
    char U294[34];
    char U295[1];
  } U293;
  struct {
    char U297[34];
    char U298[1];
  } U296;
  struct {
    char U300[34];
    char U301[1];
  } U299;
  struct {
    char U303[34];
    char U304[1];
  } U302;
  struct {
    char U306[34];
    char U307[1];
  } U305;
  struct {
    char U309[34];
    char U310[1];
  } U308;
  struct {
    char U312[34];
    char U313[1];
  } U311;
  struct {
    char U315[34];
    char U316[1];
  } U314;
  struct {
    char U318[34];
    char U319[1];
  } U317;
  struct {
    char U321[34];
    char U322[1];
  } U320;
  struct {
    char U324[34];
    char U325[1];
  } U323;
  struct {
    char U327[34];
    char U328[1];
  } U326;
  struct {
    char U330[34];
    char U331[1];
  } U329;
  struct {
    char U333[34];
    char U334[1];
  } U332;
  struct {
    char U336[34];
    char U337[1];
  } U335;
  struct {
    char U339[34];
    char U340[1];
  } U338;
  struct {
    char U342[34];
    char U343[1];
  } U341;
  struct {
    char U345[34];
    char U346[1];
  } U344;
  struct {
    char U348[34];
    char U349[1];
  } U347;
  struct {
    char U351[34];
    char U352[1];
  } U350;
  struct {
    char U354[34];
    char U355[1];
  } U353;
  struct {
    char U357[34];
    char U358[1];
  } U356;
  struct {
    char U360[34];
    char U361[1];
  } U359;
  struct {
    char U363[34];
    char U364[1];
  } U362;
  struct {
    char U366[34];
    char U367[1];
  } U365;
  struct {
    char U369[34];
    char U370[1];
  } U368;
  struct {
    char U372[34];
    char U373[1];
  } U371;
  struct {
    char U375[34];
    char U376[1];
  } U374;
  struct {
    char U378[34];
    char U379[1];
  } U377;
  struct {
    char U381[34];
    char U382[1];
  } U380;
  struct {
    char U384[34];
    char U385[1];
  } U383;
  struct {
    char U387[34];
    char U388[1];
  } U386;
  struct {
    char U390[34];
    char U391[1];
  } U389;
  struct {
    char U393[34];
    char U394[1];
  } U392;
  struct {
    char U396[34];
    char U397[1];
  } U395;
  struct {
    char U399[34];
    char U400[1];
  } U398;
  struct {
    char U402[34];
    char U403[1];
  } U401;
  struct {
    char U405[34];
    char U406[1];
  } U404;
  struct {
    char U408[34];
    char U409[1];
  } U407;
  struct {
    char U411[34];
    char U412[1];
  } U410;
  struct {
    char U414[34];
    char U415[1];
  } U413;
  struct {
    char U417[34];
    char U418[1];
  } U416;
  struct {
    char U420[34];
    char U421[1];
  } U419;
  struct {
    char U423[34];
    char U424[1];
  } U422;
  struct {
    char U426[34];
    char U427[1];
  } U425;
  struct {
    char U429[34];
    char U430[1];
  } U428;
  struct {
    char U432[34];
    char U433[1];
  } U431;
  struct {
    char U435[34];
    char U436[1];
  } U434;
  struct {
    char U438[34];
    char U439[1];
  } U437;
  struct {
    char U441[34];
    char U442[1];
  } U440;
  struct {
    char U444[34];
    char U445[1];
  } U443;
  struct {
    char U447[34];
    char U448[1];
  } U446;
  struct {
    char U450[34];
    char U451[1];
  } U449;
  struct {
    char U453[34];
    char U454[1];
  } U452;
  struct {
    char U456[34];
    char U457[1];
  } U455;
  struct {
    char U459[34];
    char U460[1];
  } U458;
  struct {
    char U462[34];
    char U463[1];
  } U461;
  struct {
    char U465[34];
    char U466[1];
  } U464;
  struct {
    char U468[34];
    char U469[1];
  } U467;
  struct {
    char U471[34];
    char U472[1];
  } U470;
  struct {
    char U474[34];
    char U475[1];
  } U473;
  struct {
    char U477[34];
    char U478[1];
  } U476;
  struct {
    char U480[34];
    char U481[1];
  } U479;
  struct {
    char U483[34];
    char U484[1];
  } U482;
  struct {
    char U486[34];
    char U487[1];
  } U485;
  struct {
    char U489[34];
    char U490[1];
  } U488;
  struct {
    char U492[34];
    char U493[1];
  } U491;
  struct {
    char U495[34];
    char U496[1];
  } U494;
  struct {
    char U498[34];
    char U499[1];
  } U497;
  struct {
    char U501[34];
    char U502[1];
  } U500;
  struct {
    char U504[34];
    char U505[1];
  } U503;
  struct {
    char U507[34];
    char U508[1];
  } U506;
  struct {
    char U510[34];
    char U511[1];
  } U509;
  struct {
    char U513[34];
    char U514[1];
  } U512;
  struct {
    char U516[34];
    char U517[1];
  } U515;
  struct {
    char U519[34];
    char U520[1];
  } U518;
  struct {
    char U522[34];
    char U523[1];
  } U521;
  struct {
    char U525[34];
    char U526[1];
  } U524;
  struct {
    char U528[34];
    char U529[1];
  } U527;
  struct {
    char U531[34];
    char U532[1];
  } U530;
  struct {
    char U534[34];
    char U535[1];
  } U533;
  struct {
    char U537[34];
    char U538[1];
  } U536;
  struct {
    char U540[34];
    char U541[1];
  } U539;
  struct {
    char U543[34];
    char U544[1];
  } U542;
  struct {
    char U546[34];
    char U547[1];
  } U545;
  struct {
    char U549[34];
    char U550[1];
  } U548;
  struct {
    char U552[34];
    char U553[1];
  } U551;
  struct {
    char U555[34];
    char U556[1];
  } U554;
  struct {
    char U558[34];
    char U559[1];
  } U557;
  struct {
    char U561[34];
    char U562[1];
  } U560;
  struct {
    char U564[34];
    char U565[1];
  } U563;
  struct {
    char U567[34];
    char U568[1];
  } U566;
  struct {
    char U570[34];
    char U571[1];
  } U569;
  struct {
    char U573[34];
    char U574[1];
  } U572;
  struct {
    char U576[34];
    char U577[1];
  } U575;
  struct {
    char U579[34];
    char U580[1];
  } U578;
  struct {
    char U582[34];
    char U583[1];
  } U581;
  struct {
    char U585[34];
    char U586[1];
  } U584;
  struct {
    char U588[34];
    char U589[1];
  } U587;
  struct {
    char U591[34];
    char U592[1];
  } U590;
  struct {
    char U594[34];
    char U595[1];
  } U593;
  struct {
    char U597[34];
    char U598[1];
  } U596;
  struct {
    char U600[34];
    char U601[1];
  } U599;
  struct {
    char U603[34];
    char U604[1];
  } U602;
  struct {
    char U606[34];
    char U607[1];
  } U605;
  struct {
    char U609[34];
    char U610[1];
  } U608;
  struct {
    char U612[34];
    char U613[1];
  } U611;
  struct {
    char U615[34];
    char U616[1];
  } U614;
  struct {
    char U618[34];
    char U619[1];
  } U617;
  struct {
    char U621[34];
    char U622[1];
  } U620;
  struct {
    char U624[34];
    char U625[1];
  } U623;
  struct {
    char U627[34];
    char U628[1];
  } U626;
  struct {
    char U630[34];
    char U631[1];
  } U629;
  struct {
    char U633[34];
    char U634[1];
  } U632;
  struct {
    char U636[34];
    char U637[1];
  } U635;
  struct {
    char U639[34];
    char U640[1];
  } U638;
  struct {
    char U642[34];
    char U643[1];
  } U641;
  struct {
    char U645[34];
    char U646[1];
  } U644;
  struct {
    char U648[34];
    char U649[1];
  } U647;
  struct {
    char U651[34];
    char U652[1];
  } U650;
  struct {
    char U654[34];
    char U655[1];
  } U653;
  struct {
    char U657[34];
    char U658[1];
  } U656;
  struct {
    char U660[34];
    char U661[1];
  } U659;
  struct {
    char U663[34];
    char U664[1];
  } U662;
  struct {
    char U666[34];
    char U667[1];
  } U665;
  struct {
    char U669[34];
    char U670[1];
  } U668;
  struct {
    char U672[34];
    char U673[1];
  } U671;
  struct {
    char U675[34];
    char U676[1];
  } U674;
  struct {
    char U678[34];
    char U679[1];
  } U677;
  struct {
    char U681[34];
    char U682[1];
  } U680;
  struct {
    char U684[34];
    char U685[1];
  } U683;
  struct {
    char U687[34];
    char U688[1];
  } U686;
  struct {
    char U690[34];
    char U691[1];
  } U689;
  struct {
    char U693[34];
    char U694[1];
  } U692;
  struct {
    char U696[34];
    char U697[1];
  } U695;
  struct {
    char U699[34];
    char U700[1];
  } U698;
  struct {
    char U702[34];
    char U703[1];
  } U701;
  struct {
    char U705[34];
    char U706[1];
  } U704;
  struct {
    char U708[34];
    char U709[1];
  } U707;
  struct {
    char U711[34];
    char U712[1];
  } U710;
  struct {
    char U714[34];
    char U715[1];
  } U713;
  struct {
    char U717[34];
    char U718[1];
  } U716;
  struct {
    char U720[34];
    char U721[1];
  } U719;
} *home;

static void VSET_7_(unsigned short newstate) {
  static unsigned short oldstate;
  
  switch (oldstate) {
  }
  oldstate = newstate;
  switch (newstate) {
  }
}
static void VSET_6_(unsigned short newstate) {
  static unsigned short oldstate;
  
  switch (oldstate) {
  }
  oldstate = newstate;
  switch (newstate) {
  }
}
static void VSET_5_(unsigned short newstate) {
  static unsigned short oldstate;
  
  switch (oldstate) {
    case 2: /* REVEAL */
      V10 |= 0x1;
      break;
  }
  oldstate = newstate;
  switch (newstate) {
    case 2: /* REVEAL */ {
        V10 &= ~0x1;
        {
          tma_init_state( 1, REVEAL_cmds_, "REVEAL" ); VSET_7_(1);
        }
      }
      break;
    case 1: /* REVEAL_Idle */ {
        {
          tma_init_state( 1, REVEAL_Idle_cmds_, "REVEAL_Idle" ); VSET_7_(1);
        }
      }
      break;
  }
}
static void VSET_4_(unsigned short newstate) {
  static unsigned short oldstate;
  
  switch (oldstate) {
  }
  oldstate = newstate;
  switch (newstate) {
    case 1: /* initialize */ {
        {
          tma_init_state( 0, initialize_cmds_, "initialize" ); VSET_6_(1);
        }
      }
      break;
  }
}
static void VSET_3_(unsigned short newstate) {
  static unsigned short oldstate;
  
  switch (oldstate) {
    case 2: /* MaycommTog */
      V8 |= 0x1;
      break;
  }
  oldstate = newstate;
  switch (newstate) {
    case 2: /* MaycommTog */
      V8 &= ~0x1;
      break;
  }
}
static void VSET_2_(unsigned short newstate) {
  static unsigned short oldstate;
  
  switch (oldstate) {
    case 3: /* Injection_MSD */
      V6 |= 0x1;
      break;
    case 2: /* Injecting_MSD */ {
        V7 |= 0x1;
        V5 |= 0x1;
      }
      break;
  }
  oldstate = newstate;
  switch (newstate) {
    case 3: /* Injection_MSD */
      V6 &= ~0x1;
      break;
    case 2: /* Injecting_MSD */ {
        V7 &= ~0x1;
        V5 &= ~0x1;
        {
        	msdTIMEoldPlot = 0;
        }
      }
      break;
    case 1: /* NotInjecting_MSD */ {
        {
        	ReadMSDionFile( MSDIONFILE );
        } {
        	InitializeMSDeng();
        }
      }
      break;
  }
}
static void VSET_1_(unsigned short newstate) {
  static unsigned short oldstate;
  
  switch (oldstate) {
    case 2: /* GCTog */
      V3 |= 0x1;
      break;
  }
  oldstate = newstate;
  switch (newstate) {
    case 2: /* GCTog */
      V3 &= ~0x1;
      break;
  }
}
static void VSET_0_(unsigned short newstate) {
  static unsigned short oldstate;
  
  switch (oldstate) {
    case 3: /* Injection */
      V1 |= 0x1;
      break;
    case 2: /* Injecting */ {
        V4 |= 0x1;
        V2 |= 0x1;
        V0 |= 0x1;
      }
      break;
  }
  oldstate = newstate;
  switch (newstate) {
    case 3: /* Injection */
      V1 &= ~0x1;
      break;
    case 2: /* Injecting */ {
        V4 &= ~0x1;
        V2 &= ~0x1;
        V0 &= ~0x1;
      }
      break;
  }
}
static void tminitfunc(void) {VSET_0_(1);VSET_1_(1);VSET_2_(1);VSET_3_(1);VSET_4_(1);VSET_5_(1);VSET_6_(1);VSET_7_(1);
}
#define TMINITFUNC tminitfunc()

static void nullfunc(void);
static void EF2_0(void) {
  {
  
  	for(chanInc=0; chanInc<MAXMSDCHANS; chanInc++) {
  		MSD_ChanX = MSDMISSING;
  		switch( chanInc ) {
  			case 0:
  				MSD_ChanX = home->U73.MSD_Chan0; break;
  			case 1:
  				MSD_ChanX = home->U80.MSD_Chan1; break;
  			case 2:
  				MSD_ChanX = home->U70.MSD_Chan2; break;
  			case 3:
  				MSD_ChanX = home->U20.MSD_Chan3; break;
  			case 4:
  				MSD_ChanX = home->U2.MSD_Chan4; break;
  			case 5:
  				MSD_ChanX = home->U2.MSD_Chan5; break;
  			case 6:
  				MSD_ChanX = home->U2.MSD_Chan5; break;
  			case 7:
  				MSD_ChanX = home->U2.MSD_Chan5; break;
  			default:
  				chanInc = MAXMSDCHANS-1; MSD_ChanX = MSDMISSING; break;
  		}
  
  		if ( MSD_ChanX > 0 ) {
  			msd_sum[chanInc] += MSD_ChanX;
  			MSchanAvg[chanInc]++;
  		}
  	}
  }
}

static void BF32_0(void) {
  EF2_0();
  if (!(V0)) {
    {
      if ( home->U12.GCstate == 2 ) VSET_0_(3);
    }
  }
    else {
      if ( home->U12.GCstate == 1 ) VSET_0_(2);
      if ( home->U12.GCstate == 0 ) VSET_0_(1);
    }
  {if (!(V1)) {
    { CHROMtime += 1; InjectingInc = 0; }
  }if (!(V2)) {
    { 
    	if (InjectingInc == 0 ) {
    		CHROMtime = 1; 
    		InjectingInc = 1;
    	}
    	else CHROMtime += 1;
      }
  }
  }
  {	
  	if (rs485_proxy != 0)  Trigger ( rs485_proxy );
  }
  {
  	if (ECDresp_proxy != 0) Trigger ( ECDresp_proxy );
  }
  {if (!(V3)) {
    { VSET_1_(1);
    	}
  }if (!(V4)) {
    V4 |= 0x1;
    { VSET_1_(2);
    		ecdSF6x = 0.0;
    		ecdF11x = 0.0;
    		ecdCOx  = 0.0;
    		ecdPANx = 0.0;
    	}
  }
  
  	if ( ecdSF6x > NUMSECSXAXIS ) { VSET_1_(2);
  		ecdSF6x = 0.0;
  		ecdF11x = 0.0;
  		ecdCOx  = 0.0;
  		ecdPANx = 0.0;
  	}
  }
  {
  	if ( DetAvgCt1 > 0 ) {
  		ecdA_SF6 = ecd_sum1/DetAvgCt1;
  		ecdA_SF6save = ecdA_SF6;
  		DetAvgCt1 = 0;
  		ecd_sum1 = 0;
  		DetAvgOffline1 = 0;
  	} 
  	else if (( ecdA_SF6save > 0 ) && ( DetAvgOffline1 < 1 )) {
  		DetAvgOffline1++;
  		ecdA_SF6 = ecdA_SF6save;
  	}
  	else {
  		ecdA_SF6 = ECDOFFLINE;
  		ecdA_SF6save = 0;
  	}
  
  	if ( DetAvgCt2 > 0 ) {
  		ecdA_F11 = ecd_sum2/DetAvgCt2;
  		ecdA_F11save = ecdA_F11;
  		DetAvgCt2 = 0;
  		ecd_sum2 = 0;
  		DetAvgOffline2 = 0;
  	} 
  	else if (( ecdA_F11save > 0 ) && ( DetAvgOffline2 < 1 )) {
  		DetAvgOffline2++;
  		ecdA_F11 = ecdA_F11save;
  	}
  	else {
  		ecdA_F11 = ECDOFFLINE;
  		ecdA_F11save = 0;
  	}
  
  	if ( DetAvgCt3 > 0 ) {
  		ecdA_CO = ecd_sum3/DetAvgCt3;
  		ecdA_COsave = ecdA_CO;
  		DetAvgCt3 = 0;
  		ecd_sum3 = 0;
  		DetAvgOffline3 = 0;
  	} 
  	else if (( ecdA_COsave > 0 ) && ( DetAvgOffline3 < 1 )) {
  		DetAvgOffline3++;
  		ecdA_CO = ecdA_COsave;
  	}
  	else {
  		ecdA_CO = ECDOFFLINE;
  		ecdA_COsave = 0;
  	}
  
  	if ( DetAvgCt4 > 0 ) {
  		ecdA_PAN = ecd_sum4/DetAvgCt4;
  		ecdA_PANsave = ecdA_PAN;
  		DetAvgCt4 = 0;
  		ecd_sum4 = 0;
  		DetAvgOffline4 = 0;
  	} 
  	else if (( ecdA_PANsave > 0 ) && ( DetAvgOffline4 < 1 )) {
  		DetAvgOffline4++;
  		ecdA_PAN = ecdA_PANsave;
  	}
  	else {
  		ecdA_PAN = ECDOFFLINE;
  		ecdA_PANsave = 0;
  	}
  
  }
  {
   	++CUMSEC;
  }
  {
  	if ( MSchanAvg[0] > 0 ) {
  		msdA_0 = msd_sum[0]/MSchanAvg[0];
  		MSchanAvg[0] = msd_sum[0] = 0;
  	} else {
  		msdA_0 = MSDOFFLINE;
  	}
  
  	if ( MSchanAvg[1] > 0 ) {
  		msdA_1 = msd_sum[1]/MSchanAvg[1];
  		MSchanAvg[1] = msd_sum[1] = 0;
  	} else {
  		msdA_1 = MSDOFFLINE;
  	}
  
  	if ( MSchanAvg[2] > 0 ) {
  		msdA_2 = msd_sum[2]/MSchanAvg[2];
  		MSchanAvg[2] = msd_sum[2] = 0;
  	} else {
  		msdA_2 = MSDOFFLINE;
  	}
  
  	if ( MSchanAvg[3] > 0 ) {
  		msdA_3 = msd_sum[3]/MSchanAvg[3];
  		MSchanAvg[3] = msd_sum[3] = 0;
  	} else {
  		msdA_3 = MSDOFFLINE;
  	}
  
  	if ( MSchanAvg[4] > 0 ) {
  		msdA_4 = msd_sum[4]/MSchanAvg[4];
  		MSchanAvg[4] = msd_sum[4] = 0;
  	} else {
  		msdA_4 = MSDOFFLINE;
  	}
  
  	if ( MSchanAvg[5] > 0 ) {
  		msdA_5 = msd_sum[5]/MSchanAvg[5];
  		MSchanAvg[5] = msd_sum[5] = 0;
  	} else {
  		msdA_5 = MSDOFFLINE;
  	}
  
  	if ( MSchanAvg[6] > 0 ) {
  		msdA_6 = msd_sum[6]/MSchanAvg[6];
  		MSchanAvg[6] = msd_sum[6] = 0;
  	} else {
  		msdA_6 = MSDOFFLINE;
  	}
  
  	if ( MSchanAvg[7] > 0 ) {
  		msdA_7 = msd_sum[7]/MSchanAvg[7];
  		MSchanAvg[7] = msd_sum[7] = 0;
  	} else {
  		msdA_7 = MSDOFFLINE;
  	}
  
  }
  {if (!(V6)) {
    { 
    	MSDchromtime += 1; 
    	InjectingInc_MSD = 0;
      }
  }if (!(V7)) {
    { 
    	if ( InjectingInc_MSD == 0 ) {
    		MSDchromtime = 1; 
    		InjectingInc_MSD = 1;
    	} else 
    		MSDchromtime += 1;
      }
  }
  }
  {
  	if (maycomm_proxy != 0)  Trigger ( maycomm_proxy );
  }
  {
    long int it;
    int subcase;
  
    it = itime();
    ci_settime( it );
    while ( subcase = tma_process( it ) ) {
  	switch (subcase) {
  	  case -1:
  	  case 0: break;
  	  case 1: VSET_4_(1); break;
  	  case 2: VSET_5_(1); break;
  	  case 3: VSET_5_(2); break;
  	  case 4: VSET_6_(1); break;
  	  case 5: VSET_7_(1); break;
  	  default:
  		nl_error( 1, "Unexpected return value from tma_process" );
  		break;
  	}
    }
  }
}

static void EF2_1(void) {
  {
  	if (home->U0.GC_Ctr_SF6 >= 0) {
  		ecd_sum1 += home->U0.GC_Ctr_SF6;
  		DetAvgCt1++;
  		ecdSF6x += ELECRATE;
  	} 
  	if (home->U0.GC_Ctr_F11 >= 0) {
  		ecd_sum2 += home->U0.GC_Ctr_F11;
  		DetAvgCt2++;
  		ecdF11x += ELECRATE;
  	}
  	if (home->U0.GC_Ctr_CO >= 0) {
  		ecd_sum3 += home->U0.GC_Ctr_CO;
  		DetAvgCt3++;
  		ecdCOx += ELECRATE;
  	}
  	if (home->U0.GC_Ctr_PAN >= 0) {
  		ecd_sum4 += home->U0.GC_Ctr_PAN;
  		DetAvgCt4++;
  		ecdPANx += ELECRATE;
  	}
  }
}

static void BF32_1(void) {
  tdlbH2O = home->U98.tdlbH2O; {
    V10 &= ~0x2;
    V9 &= ~0x2;
  }
  EF2_1();
  {
  		MSDstateS = home->U15.MSDstate;
  	}
  if (!(V5)) {
    {
      if ( home->U15.MSDstate == 2 ) VSET_2_(3);
    }
  }
    else {
      if ( home->U15.MSDstate == 1 ) VSET_2_(2);
      else if ( home->U15.MSDstate == 0 ) VSET_2_(1);
    }
  home->U95.maycX++;
  {if (!(V8)) {
    { VSET_3_(1); }
  }
  
  	if ( home->U95.maycX >= 120 ) { 
  		home->U95.maycX = 0; VSET_3_(2);
  	}
  }
}

static void BF320_2(void) {
  memcpy(&VoltE_SF6, home->U113.U115, 1);
  EF2_0();
}

static void BF32_3(void) {
  memcpy(&tdllH2O, home->U719.U721, 1);
  V9 &= ~0x1;
  EF2_1();
}

static void BF320_4(void) {
  memcpy(&Flow_PANsl, home->U305.U307, 1);
  EF2_0();
}

static void BF32_5(void) {
  tdlP = home->U55.tdlP;
  tdlT = home->U55.tdlT;
  memcpy(((char*)(&tdllH2O))+1, home->U55.U57, 3);
  V10 &= ~0x4;
  EF2_1();
  if (!(V9)) {
    {
    	tdlbH2O = tdllH2O;
    	if ( tdllH2O > USELONGPATH ) tdlbH2O = home->U55.tdlsH2O; 
    }
  }
}

static void BF320_6(void) {
  memcpy(((char*)(&Flow_PANsl))+1, home->U302.U304, 1);
  EF2_0();
}

static void BF320_7(void) {
  memcpy(((char*)(&Flow_PANsl))+2, home->U299.U301, 1);
  EF2_1();
}

static void BF320_8(void) {
  memcpy(((char*)(&Flow_PANsl))+3, home->U296.U298, 1);
  EF2_0();
}

static void BF320_9(void) {
  memcpy(&Flow_Packsl, home->U293.U295, 1);
  EF2_1();
}

static void BF320_10(void) {
  memcpy(((char*)(&Flow_Packsl))+1, home->U290.U292, 1);
  EF2_0();
}

static void EF32_11(void) {
  EF2_1();
  { ITXFileNum = home->U12.CurrInj * 1000 + home->U2.CurrFile;
  }
}

static void BF320_11(void) {
  memcpy(((char*)(&Flow_Packsl))+2, home->U287.U289, 1);
  EF32_11();
}

static void BF320_12(void) {
  memcpy(((char*)(&Flow_Packsl))+3, home->U284.U286, 1);
  EF2_0();
}

static void BF320_13(void) {
  memcpy(&Flow_MSsl, home->U281.U283, 1);
  EF2_1();
}

static void BF320_14(void) {
  memcpy(((char*)(&Flow_MSsl))+1, home->U278.U280, 1);
  EF2_0();
}

static void BF320_15(void) {
  memcpy(((char*)(&Flow_MSsl))+2, home->U275.U277, 1);
  EF2_1();
}

static void BF320_16(void) {
  memcpy(((char*)(&Flow_MSsl))+3, home->U272.U274, 1);
  EF2_0();
}

static void EF64_21(void) {
  memcpy(&msdMASO, home->U92.U94, 3);
  EF2_1();
}

static void BF320_21(void) {
  memcpy(((char*)(&VoltE_SF6))+1, home->U31.U34, 2);
  memcpy(&VoltBP_5, home->U101.U103, 2);
  EF64_21();
}

static void BF64_23(void) {
  memcpy(&msdTURBOPCT, home->U108.U110, 4);
  memcpy(((char*)(&msdMASO))+3, home->U52.U54, 5);
  EF2_1();
}

static void BF64_25(void) {
  memcpy(&msdSRCTEMP, home->U716.U718, 1);
  memcpy(((char*)(&msdTURBOPCT))+4, home->U76.U78, 4);
  EF2_1();
}

static void BF64_27(void) {
  memcpy(&msdCAL, home->U101.U104, 2);
  memcpy(((char*)(&msdSRCTEMP))+1, home->U48.U50, 7);
  EF2_1();
}

static void BF64_29(void) {
  memcpy(&msdENTO, home->U89.U91, 3);
  memcpy(((char*)(&msdCAL))+2, home->U43.U45, 6);
  EF2_1();
}

static void BF64_31(void) {
  memcpy(&msdFSEL, home->U105.U107, 4);
  memcpy(((char*)(&msdENTO))+3, home->U40.U42, 5);
  EF2_1();
}

static void BF320_53(void) {
  memcpy(((char*)(&VoltE_SF6))+3, home->U2.U5, 1);
  memcpy(&VoltBP_CO, home->U20.U22, 2);
  EF2_1();
}

static void BF64_55(void) {
  memcpy(&msdIFOC, home->U80.U82, 5);
  memcpy(((char*)(&msdFSEL))+4, home->U35.U37, 4);
  EF2_1();
}

static void BF320_57(void) {
  memcpy(&PresE_5, home->U35.U39, 3);
  memcpy(((char*)(&VoltBP_5))+2, home->U12.U14, 2);
  EF2_1();
}

static void BF64_59(void) {
  memcpy(&msdAMUG, home->U43.U47, 6);
  memcpy(((char*)(&msdIFOC))+5, home->U31.U33, 3);
  EF2_1();
}

static void BF64_61(void) {
  memcpy(&msdREP, home->U83.U85, 7);
  memcpy(((char*)(&msdAMUG))+6, home->U27.U29, 2);
  EF2_1();
}

static void BF64_63(void) {
  memcpy(((char*)(&msdREP))+7, home->U24.U26, 1);
  EF2_1();
}

static void BF320_117(void) {
  memcpy(&PresE_F11, home->U20.U23, 3);
  EF2_1();
}

static void BF320_121(void) {
  memcpy(((char*)(&PresE_5))+3, home->U9.U11, 1);
  EF2_1();
}

static void BF320_132(void) {
  memcpy(&PresH_He, home->U389.U391, 1);
  V10 &= ~0x400;
  EF2_0();
}

static void BF320_134(void) {
  memcpy(((char*)(&PresH_He))+1, home->U386.U388, 1);
  V10 &= ~0x800;
  EF2_0();
}

static void BF320_135(void) {
  memcpy(((char*)(&PresH_He))+2, home->U383.U385, 1);
  V10 &= ~0x1000;
  EF2_1();
}

static void BF320_136(void) {
  memcpy(((char*)(&PresH_He))+3, home->U380.U382, 1);
  V10 &= ~0x2000;
  EF2_0();
}

static void BF320_137(void) {
  memcpy(&PresH_N2, home->U401.U403, 1);
  V10 &= ~0x40;
  EF2_1();
}

static void BF320_138(void) {
  memcpy(((char*)(&PresH_N2))+1, home->U398.U400, 1);
  V10 &= ~0x80;
  EF2_0();
}

static void BF320_139(void) {
  memcpy(((char*)(&PresH_N2))+2, home->U395.U397, 1);
  V10 &= ~0x100;
  EF32_11();
}

static void BF320_140(void) {
  memcpy(((char*)(&PresH_N2))+3, home->U392.U394, 1);
  V10 &= ~0x200;
  EF2_0();
}

static void BF320_181(void) {
  memcpy(&VoltM_PAN, home->U27.U30, 3);
  EF2_1();
}

static void BF320_185(void) {
  memcpy(&PresE_CO, home->U17.U19, 3);
  memcpy(((char*)(&VoltBP_CO))+2, home->U2.U4, 2);
  EF2_1();
}

static void BF320_243(void) {
  memcpy(&Temp_GasBot, home->U581.U583, 1);
  V10 &= ~0x8;
  EF2_1();
}

static void BF320_244(void) {
  memcpy(((char*)(&Temp_GasBot))+1, home->U578.U580, 1);
  V10 &= ~0x10;
  EF2_0();
}

static void BF320_245(void) {
  memcpy(&PresSrc_PAN, home->U48.U51, 2);
  memcpy(((char*)(&VoltM_PAN))+3, home->U43.U46, 1);
  EF2_1();
}

static void BF320_246(void) {
  memcpy(((char*)(&Temp_GasBot))+2, home->U575.U577, 1);
  V10 &= ~0x20;
  EF2_0();
}

static void BF320_248(void) {
  memcpy(((char*)(&Temp_GasBot))+3, home->U572.U574, 1);
  EF2_0();
  if (!(V10)) {
    {
    		revinc++;
    		sprintf ( revealMSG, "xPAN:%08.1f,%04.0f,%04.0f,%05d,%05d,%03.0f,%04.0f,%04.0f", 
    			tdlbH2O, tdlT, tdlP, 
    			revinc, revinc++, Temp_GasBot, PresH_N2, PresH_He );
    		if ( strlen(revealMSG) <= REVEAL_MAXDATA ) 
    			send2reveal( &revealMSG );
    		msg( 0, "** REVEAL:%s", revealMSG );
    
    	}
  }
}

static void BF320_249(void) {
  memcpy(((char*)(&PresE_CO))+3, home->U0.U1, 1);
  EF2_1();
}

static void BF320_309(void) {
  memcpy(((char*)(&PresSrc_PAN))+2, home->U35.U38, 2);
  EF2_1();
}

static void BF320_313(void) {
  memcpy(((char*)(&PresE_F11))+3, home->U6.U8, 1);
  EF2_1();
}

static void (*efuncs[320])() = {
  BF32_0,
  BF32_1,
  BF320_2,
  BF32_3,
  BF320_4,
  BF32_5,
  BF320_6,
  BF320_7,
  BF320_8,
  BF320_9,
  BF320_10,
  BF320_11,
  BF320_12,
  BF320_13,
  BF320_14,
  BF320_15,
  BF320_16,
  EF2_1,
  EF2_0,
  EF2_1,
  EF2_0,
  BF320_21,
  EF2_0,
  BF64_23,
  EF2_0,
  BF64_25,
  EF2_0,
  BF64_27,
  EF2_0,
  BF64_29,
  EF2_0,
  BF64_31,
  BF32_0,
  BF32_1,
  EF2_0,
  BF32_3,
  EF2_0,
  BF32_5,
  EF2_0,
  EF2_1,
  EF2_0,
  EF2_1,
  EF2_0,
  EF32_11,
  EF2_0,
  EF2_1,
  EF2_0,
  EF2_1,
  EF2_0,
  EF2_1,
  EF2_0,
  EF2_1,
  EF2_0,
  BF320_53,
  EF2_0,
  BF64_55,
  EF2_0,
  BF320_57,
  EF2_0,
  BF64_59,
  EF2_0,
  BF64_61,
  EF2_0,
  BF64_63,
  BF32_0,
  BF32_1,
  EF2_0,
  BF32_3,
  EF2_0,
  BF32_5,
  EF2_0,
  EF2_1,
  EF2_0,
  EF2_1,
  EF2_0,
  EF32_11,
  EF2_0,
  EF2_1,
  EF2_0,
  EF2_1,
  EF2_0,
  EF2_1,
  EF2_0,
  EF2_1,
  EF2_0,
  EF64_21,
  EF2_0,
  BF64_23,
  EF2_0,
  BF64_25,
  EF2_0,
  BF64_27,
  EF2_0,
  BF64_29,
  EF2_0,
  BF64_31,
  BF32_0,
  BF32_1,
  EF2_0,
  BF32_3,
  EF2_0,
  BF32_5,
  EF2_0,
  EF2_1,
  EF2_0,
  EF2_1,
  EF2_0,
  EF32_11,
  EF2_0,
  EF2_1,
  EF2_0,
  EF2_1,
  EF2_0,
  EF2_1,
  EF2_0,
  EF2_1,
  EF2_0,
  BF320_117,
  EF2_0,
  BF64_55,
  EF2_0,
  BF320_121,
  EF2_0,
  BF64_59,
  EF2_0,
  BF64_61,
  EF2_0,
  BF64_63,
  BF32_0,
  BF32_1,
  EF2_0,
  BF32_3,
  BF320_132,
  BF32_5,
  BF320_134,
  BF320_135,
  BF320_136,
  BF320_137,
  BF320_138,
  BF320_139,
  BF320_140,
  EF2_1,
  EF2_0,
  EF2_1,
  EF2_0,
  EF2_1,
  EF2_0,
  EF2_1,
  EF2_0,
  EF64_21,
  EF2_0,
  BF64_23,
  EF2_0,
  BF64_25,
  EF2_0,
  BF64_27,
  EF2_0,
  BF64_29,
  EF2_0,
  BF64_31,
  BF32_0,
  BF32_1,
  EF2_0,
  BF32_3,
  EF2_0,
  BF32_5,
  EF2_0,
  EF2_1,
  EF2_0,
  EF2_1,
  EF2_0,
  EF32_11,
  EF2_0,
  EF2_1,
  EF2_0,
  EF2_1,
  EF2_0,
  EF2_1,
  EF2_0,
  EF2_1,
  EF2_0,
  BF320_181,
  EF2_0,
  BF64_55,
  EF2_0,
  BF320_185,
  EF2_0,
  BF64_59,
  EF2_0,
  BF64_61,
  EF2_0,
  BF64_63,
  BF32_0,
  BF32_1,
  EF2_0,
  BF32_3,
  EF2_0,
  BF32_5,
  EF2_0,
  EF2_1,
  EF2_0,
  EF2_1,
  EF2_0,
  EF32_11,
  EF2_0,
  EF2_1,
  EF2_0,
  EF2_1,
  EF2_0,
  EF2_1,
  EF2_0,
  EF2_1,
  EF2_0,
  EF64_21,
  EF2_0,
  BF64_23,
  EF2_0,
  BF64_25,
  EF2_0,
  BF64_27,
  EF2_0,
  BF64_29,
  EF2_0,
  BF64_31,
  BF32_0,
  BF32_1,
  EF2_0,
  BF32_3,
  EF2_0,
  BF32_5,
  EF2_0,
  EF2_1,
  EF2_0,
  EF2_1,
  EF2_0,
  EF32_11,
  EF2_0,
  EF2_1,
  EF2_0,
  EF2_1,
  EF2_0,
  EF2_1,
  EF2_0,
  BF320_243,
  BF320_244,
  BF320_245,
  BF320_246,
  BF64_55,
  BF320_248,
  BF320_249,
  EF2_0,
  BF64_59,
  EF2_0,
  BF64_61,
  EF2_0,
  BF64_63,
  BF32_0,
  BF32_1,
  EF2_0,
  BF32_3,
  EF2_0,
  BF32_5,
  EF2_0,
  EF2_1,
  EF2_0,
  EF2_1,
  EF2_0,
  EF32_11,
  EF2_0,
  EF2_1,
  EF2_0,
  EF2_1,
  EF2_0,
  EF2_1,
  EF2_0,
  EF2_1,
  EF2_0,
  EF64_21,
  EF2_0,
  BF64_23,
  EF2_0,
  BF64_25,
  EF2_0,
  BF64_27,
  EF2_0,
  BF64_29,
  EF2_0,
  BF64_31,
  BF32_0,
  BF32_1,
  EF2_0,
  BF32_3,
  EF2_0,
  BF32_5,
  EF2_0,
  EF2_1,
  EF2_0,
  EF2_1,
  EF2_0,
  EF32_11,
  EF2_0,
  EF2_1,
  EF2_0,
  EF2_1,
  EF2_0,
  EF2_1,
  EF2_0,
  EF2_1,
  EF2_0,
  BF320_309,
  EF2_0,
  BF64_55,
  EF2_0,
  BF320_313,
  EF2_0,
  BF64_59,
  EF2_0,
  BF64_61,
  EF2_0,
  BF64_63
};

static void IVF32_1(void) { {
    V10 |= 0x2;
    V9 |= 0x2;
  }
}
static void IVF32_3(void) {
  V9 |= 0x1;
}
static void IVF32_5(void) {
  V10 |= 0x4;
}
static void IVF320_132(void) {
  V10 |= 0x400;
}
static void IVF320_134(void) {
  V10 |= 0x800;
}
static void IVF320_135(void) {
  V10 |= 0x1000;
}
static void IVF320_136(void) {
  V10 |= 0x2000;
}
static void IVF320_137(void) {
  V10 |= 0x40;
}
static void IVF320_138(void) {
  V10 |= 0x80;
}
static void IVF320_139(void) {
  V10 |= 0x100;
}
static void IVF320_140(void) {
  V10 |= 0x200;
}
static void IVF320_243(void) {
  V10 |= 0x8;
}
static void IVF320_244(void) {
  V10 |= 0x10;
}
static void IVF320_246(void) {
  V10 |= 0x20;
}
#define IVFUNCS
static void (*ivfuncs[320])() = {
  nullfunc,
  IVF32_1,
  nullfunc,
  IVF32_3,
  nullfunc,
  IVF32_5,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  IVF32_1,
  nullfunc,
  IVF32_3,
  nullfunc,
  IVF32_5,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  IVF32_1,
  nullfunc,
  IVF32_3,
  nullfunc,
  IVF32_5,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  IVF32_1,
  nullfunc,
  IVF32_3,
  nullfunc,
  IVF32_5,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  IVF32_1,
  nullfunc,
  IVF32_3,
  IVF320_132,
  IVF32_5,
  IVF320_134,
  IVF320_135,
  IVF320_136,
  IVF320_137,
  IVF320_138,
  IVF320_139,
  IVF320_140,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  IVF32_1,
  nullfunc,
  IVF32_3,
  nullfunc,
  IVF32_5,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  IVF32_1,
  nullfunc,
  IVF32_3,
  nullfunc,
  IVF32_5,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  IVF32_1,
  nullfunc,
  IVF32_3,
  nullfunc,
  IVF32_5,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  IVF320_243,
  IVF320_244,
  nullfunc,
  IVF320_246,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  IVF32_1,
  nullfunc,
  IVF32_3,
  nullfunc,
  IVF32_5,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  IVF32_1,
  nullfunc,
  IVF32_3,
  nullfunc,
  IVF32_5,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc
};

static void nullfunc(void){}
#define TRN 320
#define TRD 1
#define LOWLIM (-2880)
#define HIGHLIM (2880)
#define NBROW 37
#define NROWMINF 1
#define NSECSPER 1
#define NROWSPER 32
#define ROLLOVER 65280
#define SYNCHVAL 0xABB4
#define NROWMAJF 320
#define MFSECNUM 32
#define MFSECDEN 1
#define SECDRIFT 90
#define COPY_MFCtr
#define MFCtr home->U0.MFCtr

#ifndef EXTRACTION_INIT
  #define EXTRACTION_INIT
#endif
#ifndef OPT_EXT_INIT
  #define OPT_EXT_INIT
#endif
#ifndef EXTRACTION_TERM
  #define EXTRACTION_TERM
#endif
#ifndef TMINITFUNC
  #define TMINITFUNC
#endif

static unsigned int next_minor_frame, majf_row;
#if (NROWMINF != 1)
  static unsigned int minf_row = 0;
#endif
#ifdef NEED_TIME_FUNCS
  static unsigned short CurMFC;
#endif


void main(int argc, char **argv) {
  oui_init_options(argc, argv);

  TMINITFUNC;
  BEGIN_MSG;
  EXTRACTION_INIT;
  DC_operate();
  EXTRACTION_TERM;
  DONE_MSG;
}


#define MKDCTV(x,y) ((x<<8)|y)
#define DCTV(x,y) MKDCTV(DCT_##x,DCV_##y)

/* The main thing we need to do is reset our row counter on TM START */
void DC_DASCmd(unsigned char type, unsigned char val) {
  switch (MKDCTV(type, val)) {
	case DCTV(TM,TM_START):
	  next_minor_frame = majf_row = 0;
	  #if (NROWMINF != 1)
		minf_row = 0;
	  #endif
	  break;
	case DCTV(TM,TM_END):
	case DCTV(QUIT,QUIT):
	default:
	  break;
  }
}

#define incmod(x,y) if (x==((y)-1)) x = 0; else x++

void DC_data(dbr_data_type *dr_data) {
  unsigned short nrows;

  for (nrows = dr_data->n_rows, home = (void *) &dr_data->data[0];
	   nrows > 0;
	   nrows--, home ++) {

	/* First check the minor frame counter if necessary */
	#if (NROWMINF != 1)
	if (minf_row == 0) {
	#endif
	  COPY_MFCtr /* Needs to be defined by TMC */
	  #ifdef NEED_TIME_FUNCS
		CurMFC = MFCtr;
	  #endif
	  {
		unsigned short delta;
		
		delta = MFCtr - next_minor_frame;
		if (delta != 0) {
		  #ifdef IVFUNCS
			if (delta > NROWMAJF/NROWMINF) delta = NROWMAJF;
			else delta *= NROWMINF;
			/* delta is now the number of rows skipped up to a maximum of
			  nrowmajf. While invalidating, I don't need to update
			  minf_row, since the final will be 0, same as before.
			  MFCtr is already set, and majf_row is updated.
			*/
			while (delta-- > 0)
			  ivfuncs[majf_row]();
		  #endif
		  majf_row = (((unsigned short)MFCtr) % (NROWMAJF/NROWMINF))
							  * NROWMINF;
		}
	  }
	  next_minor_frame = MFCtr+1;
	#if (NROWMINF != 1)
	}
	#endif
	
	/* Now process the row */
	efuncs[majf_row]();
	incmod(majf_row, NROWMAJF);
	#if (NROWMINF != 1)
	  incmod(minf_row, NROWMINF);
	#endif
  }
}

#ifdef __WATCOMC__
  #pragma off (unreferenced)
#endif

void DC_tstamp(tstamp_type *tstamp) { /* Nothing to do! */ }

void DC_other(unsigned char *msg_ptr, int sent_tid) {
  unsigned char rep_msg = DAS_UNKN;

  Reply(sent_tid, &rep_msg, 1);
}

#ifdef __WATCOMC__
  #pragma on (unreferenced)
#endif

#ifdef NEED_TIME_FUNCS
  #if (NROWMINF != 1)
	#define ROWS(x) (((unsigned long)(x))*NROWMINF+minf_row)
  #else
	#define ROWS(x) (x)
  #endif
  #if (NSECSPER != 1)
	#define FRACSECS(x) (((unsigned long)ROWS(x))*NSECSPER)
  #else
	#define FRACSECS(x) ROWS(x)
  #endif
  long itime(void) {
	  return(dbr_info.t_stmp.secs +
		FRACSECS(CurMFC-dbr_info.t_stmp.mfc_num)
	#if (NROWSPER != 1)
		  / NROWSPER
	#endif
		  );
  }
  double dtime(void) {
	  return(dbr_info.t_stmp.secs +
		(double) FRACSECS(CurMFC-dbr_info.t_stmp.mfc_num)
	#if (NROWSPER != 1)
		  / NROWSPER
	#endif
		  );
  }
  double etime(void) {
	double t;
	static double t0 = -1e9;
	
	t = dtime();
	if (t0 == -1e9) t0 = t;
	return(t - t0);
  }
#endif

dbr_info_type dbr_info = {
  "", /* tmid */
  37, /* NBMINF */
  37, /* NBROW */
  320, /* NROWSMAJF */
  1, /* NSECSPER */
  32, /* NROWSPER */
  0, 1, /* MFC lsb col, msb col */
  0xABB4, /* Synch Value */
  0 /* not inverted */
};
